package gonganxitong

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/community/src/api"
	"shylinux.com/x/community/src/gonganxitong/model"
)

type city struct {
	Table
	list       string `name:"list city_name auto" role:"void"`
	authCreate string `name:"authCreate" role:"tech"`
}

func (s user) Init(m *ice.Message, arg ...string) {
	cmdPortal[m.PrefixKey()] = api.GONGANXITONG_PORTAL
}
func (s street) Init(m *ice.Message, arg ...string) {
	cmdPortal[m.PrefixKey()] = api.GONGANXITONG_PORTAL
}
func (s city) Init(m *ice.Message, arg ...string) {
	cmdPortal[m.PrefixKey()] = api.GONGANXITONG_PORTAL
}
func (s city) FindOrCreateByName(m *ice.Message, arg ...string) {
	if msg := m.Cmd(s, s.Select, model.NAME, arg[1]); msg.Length() == 0 {
		msg := m.Cmd(s, s.Insert, model.NAME, arg[1])
		arg[0], arg[1] = model.CITY_UID, msg.Result()
	} else {
		arg[0], arg[1] = model.CITY_UID, msg.Append(model.UID)
	}
}
func (s city) List(m *ice.Message, arg ...string) {
	if len(arg) == 0 {
		s.Select(m).Action()
	} else if len(arg) == 1 {
		s.SelectDetail(m, model.NAME, arg[0])
		if m.Append(model.AUTH_UID) == "" && m.IsTech() {
			m.EchoInfoButton(m.Trans("please auth city", "请申请城市认证"), s.AuthCreate)
		}
	}
}
func (s city) AuthCreate(m *ice.Message, arg ...string) {
	s.Table.AuthCreate(m, 1, "", m.OptionSimple(model.NAME)...)
}
func init() { ice.TeamCtxCmd(city{}) }
