package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID             = "uid"
	NAME            = "name"
	INFO            = "info"
	TYPE            = "type"
	STATUS          = "status"
	TITLE           = "title"
	CONTENT         = "content"
	USER_UID        = "user_uid"
	USER_QUEUE_ROLE = "user_queue_role"
	QUEUE_UID       = "queue_uid"
	QUEUE_TYPE      = "queue_type"
	RECEPTION_UID   = "reception_uid"
	RECEPTION_NAME  = "reception_name"
	VOLUME_UID      = "volume_uid"
	VOLUME_TOTAL    = "volume_total"
	SCHEDULE_UID    = "schedule_uid"
	SCHEDULE_STATUS = "schedule_status"
	CALL_UID        = "call_uid"
	BEGIN_TIME      = "begin_time"
	END_TIME        = "end_time"
	CANCEL_TIME     = "cancel_time"
	TAKE_TIME       = "take_time"
	CALL_TIME       = "call_time"
	EXPIRE_TIME     = "expire_time"
	FINISH_TIME     = "finish_time"
	TOTAL           = "total"
	COUNT           = "count"
	EXPIRE          = "expire"
	FINISH          = "finish"
)

type UserQueue struct {
	db.ModelUserPlace
	QueueUID string `gorm:"type:char(32);index"`
}
type Queue struct {
	db.ModelPlace
	CompanyUID string `gorm:"type:char(32);index"`
}
type Reception struct {
	db.ModelNameInfo
	QueueUID string `gorm:"type:char(32);index"`
}
type Volume struct {
	db.ModelWithUID
	QueueUID     string `gorm:"type:char(32);index:idx_queue"`
	ReceptionUID string `gorm:"type:char(32);index:idx_queue"`
	Total        int    `gorm:"default:0"`
	Count        int    `gorm:"default:0"`
	Expire       int    `gorm:"default:0"`
	Finish       int    `gorm:"default:0"`
	BeginTime    db.Time
	EndTime      db.Time
}
type Schedule struct {
	db.ModelWithUID
	QueueUID   string `gorm:"type:char(32);index"`
	VolumeUID  string `gorm:"type:char(32)"`
	UserUID    string `gorm:"type:char(32);index"`
	CallUID    string `gorm:"type:char(32);index"`
	Status     uint8  `gorm:"default:0"`
	CancelTime db.Time
	TakeTime   db.Time
	CallTime   db.Time
	ExpireTime db.Time
	FinishTime db.Time
}

func init() { db.CmdModels("", &UserQueue{}, &Queue{}, &Reception{}, Volume{}, &Schedule{}) }
